<template>
  <div v-if="beers && beers.length > 0">
    <div class="form-group row">
      <label class="col-sm-3 col-form-label">Number on beers displayed</label>
      <div class="col-sm-2">
        <select v-model="size" @change="getBeers" class="form-control">
          <option>20</option>
          <option>50</option>
          <option>100</option>
        </select>
      </div>
    </div>
    <table class="table">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Name</th>
          <th scope="col">Comment</th>
          <th scope="col">PriceHT</th>
          <th scope="col">PriceTTC</th>
          <th scope="col">AlcoholDegree</th>
          <th scope="col">Type</th>
          <th scope="col">Owner</th>
          <th scope="col">Operations</th>
        </tr>
      </thead>
      <tbody v-for="(beer,index) in beers"  :key="index">
        <tr>
          <td>{{beer.id}}</td>
          <td>{{beer.name | beerName}}</td>
          <td>{{beer.comment}}</td>
          <td>{{beer.priceHT | currency}}</td>
          <td><priceTTC
            :value = beer.priceHT
            :isEditable = "false"
          /></td>
          <td>{{beer.alcoholDegree | degree}}</td>
          <td>{{beer.type}}</td>
          <td>{{owner}}</td>
          <td>
            <button class="btn btn-default" @click="editBeer(owner, beer)" title="Edit">
              <font-awesome-icon style='color:#ffcc00;' icon="beer" /></button>
            <button class="btn btn-default" @click="deleteBeer(owner, beer)" title="Delete">
              <font-awesome-icon style='color:red;' icon="trash-alt" /></button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
  <div v-else>
    There is no beer in the bièrothèque !
    <br>Try to add one !
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import apiRest from '@/api/apiRest'
import priceTTC from './PriceTTCtoHT'

export default {
  name: 'BeerArray',
  components: {
    priceTTC
  },
  data () {
    return {
      beers: null,
      size: 20
    }
  },
  methods: {
    async deleteBeer (owner, beer) {
      try {
        await apiRest.deleteBeer(owner, beer.id)
        this.$toasted.success('Beer deleted !', { icon: { name: 'beer', after: true } })
        this.getBeers()
      } catch {
        this.$toasted.error(`Unable to delete the beer named ${beer.name}`, { icon: { name: 'times', after: true } })
      }
    },
    async editBeer (owner, beer) {
      try {
        const response = await apiRest.getBeer(owner, beer.id)
        this.$store.commit('selectBeer', response.data)
        this.$toasted.success(`Beer ${response.data.name} loaded !`, { icon: { name: 'beer', after: true } })
        this.$router.push('/form')
      } catch {
        this.$toasted.error(`Unable to get the beer named ${beer.name}`, { icon: { name: 'times', after: true } })
      }
    },
    async getBeers () {
      try {
        const response = await apiRest.getBeers(this.$store.getters.getUser, this.size)
        this.beers = response.body.content
        this.$toasted.success('Beers loaded !', { icon: { name: 'beer', after: true } })
      } catch {
        this.$toasted.error('Unable to get beers', { icon: { name: 'times', after: true } })
      }
    }
  },
  filters: {
    beerName (value) {
      return value.toUpperCase()
    },
    currency (value) {
      return `${parseFloat(value).toFixed(2)}€`
    },
    degree (value) {
      return `${parseFloat(value).toFixed(1)}°`
    }
  },
  computed: {
    ...mapGetters({
      owner: 'getUser'
    })
  },
  mounted () {
    this.getBeers()
  }
}
</script>
